using System;
using System.Collections.Generic;

namespace FBX
{
    public class FBXNodeFactory
    {
        private static readonly Dictionary<string, Type> TokenDictionary = new Dictionary<string, Type>
                    {
                        {"Takes", typeof (NodeTakes)},
                        {"Take", typeof (NodeTake)},
                        {"Model", typeof (NodeModel)},

                        {"Objects", typeof (NodeObjects)},
                        {"Geometry", typeof (NodeGeometry)},
                        {"Vertices", typeof (NodeLista)},
                        {"PolygonVertexIndex", typeof (NodeLista)}
                    };

        private static readonly Dictionary<string, Type> AttribiuteDictionary = new Dictionary<string, Type>
                    {
                        {"\"Transform\"", typeof (NodeTransform)},
                        {"\"T\"", typeof (NodeModification)},
                        {"\"R\"", typeof (NodeModification)},
                        {"\"S\"", typeof (NodeModification)},
                        {"\"X\"", typeof (NodeXYZ)},
                        {"\"Y\"", typeof (NodeXYZ)},
                        {"\"Z\"", typeof (NodeXYZ)}                      
                    };

        public static FBXNode Get(string nodeName, string attrName)
        {
            Type typ;

            if(TokenDictionary.ContainsKey(nodeName))
                typ = TokenDictionary[nodeName];
            else if (AttribiuteDictionary.ContainsKey(attrName))
                typ = AttribiuteDictionary[attrName];
            else
                typ = typeof(FBXNode);

            return (FBXNode)Activator.CreateInstance(typ, nodeName);
        }
    }
}