﻿using System;
using Microsoft.Xna.Framework;
using System.Globalization;

namespace FBX
{
    public class KeyframeNode
    {
        private long _time;
        private Vector3 _trandlation;
        private Vector3 _rotation;
        private Vector3 _scale;
        private readonly string _attr;

        public KeyframeNode(int time, Vector3 t, Vector3 r, Vector3 s, string attr = "U, a, n")
        {
            _time = 1539538600L * 2 *  time;

            _trandlation = t;
            _rotation = r;
            _scale = s;

            _attr = attr;
        }

        public string ToString(char co, char os)
        {
            return _time.ToString(CultureInfo.InvariantCulture) + ", "
                + GetValue(co,os).ToString(CultureInfo.InvariantCulture)+ ", "
                + _attr;
        }

        public Vector3 GetRotation()
        {
            return _rotation;
        }

        public double GetValue(char co, char os)
        {
            double d = 0.0;
            if (co == 'T')
            {
                if (os == 'X') d = _trandlation.X;
                else if (os == 'Y') d = _trandlation.Y;
                else if (os == 'Z') d = _trandlation.Z;
            }
            else if (co == 'R')
            {
                if (os == 'X') d = _rotation.X * 180 / Math.PI;
                else if (os == 'Y') d = _rotation.Y * 180 / Math.PI;
                else if (os == 'Z') d = _rotation.Z * 180 / Math.PI;           
            }
            else if (co == 'S')
            {
                if (os == 'X') d = _scale.X;
                else if (os == 'Y') d = _scale.Y;
                else if (os == 'Z') d = _scale.Z;
            }

            return d;
        }
    }
}
