﻿using System;
using System.Globalization;


namespace FBX
{
    public class StringNode
    {
        private readonly string _attr;

        public StringNode()
        {
        }

        public StringNode(string s)
        {
            _attr = s;
        }

        public StringNode(double d)
        {
            _attr = d.ToString(CultureInfo.InvariantCulture);
        }

        public StringNode(int i)
        {
            _attr = i.ToString(CultureInfo.InvariantCulture);
        }
        

        public override string ToString()
        {
            return _attr;
        }

        public double ToDouble()
        {
            return Double.Parse(_attr);
        }
        
        public float ToFloat()
        {
            return (float)Double.Parse(_attr, CultureInfo.InvariantCulture);
        }

        public int ToInt()
        {
            return Int32.Parse(_attr);
        }

        public int ToIntZGwiazdka()
        {
            string tmp = _attr.Remove(0, 1);
            return Int32.Parse(tmp);
        }
    }
}
