﻿using System.Collections.Generic;
using System.IO;

namespace FBX
{
    public class Writer
    {
        private readonly List<FBXNode> _nodes;
        private TextWriter _tw;
        private int _wciecie;

        public Writer(List<FBXNode> nodes)
        {
            _wciecie = 0;
            _nodes = nodes;
        }

        public void Save(string p)
        {
            _tw = new StreamWriter(p);
        //wymagany nagłówek
            _tw.WriteLine("; FBX 6.1.0 project file");

            foreach (FBXNode node in _nodes)
            {
                _tw.WriteLine();
                SaveElement(node);
            }
            _tw.Close();
        }

        private void SaveElement(FBXNode node)
        {
            WriteTab();
            _tw.Write(node.Name + ": ");

            for (int i = 0; i < node.Attributes.Count;i++)
            {
                if(i>0)
                    _tw.Write(", ");
                _tw.Write(node.Attributes[i]);
                
            }
            if (node.Childs.Count > 0)
            {
                _tw.WriteLine("{");
                _wciecie++;
                foreach (FBXNode k in node.Childs)
                {
                    SaveElement(k);
                }
                _wciecie--;
                WriteTab();
                _tw.WriteLine("}");
            }
            else
                _tw.WriteLine("");
        }

        /// <summary>
        /// wypisuje odpowiednią ilość spacji na początku wiersza
        /// </summary>
        private void WriteTab()
        {
            for (int i = 0; i < _wciecie; i++)
                _tw.Write("    ");
        }
    }
}
