﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using SD = SlimDX.DirectInput;

namespace Rotplucs
{
    public class _CS2Connection
    {
        //button[0] (Fire), jako cięcie zamaist pedałów
        //lewe przyciski jako Zoom
        //prawe jako obrót w osi Z

        SD.Joystick joystick;
        SD.JoystickState state;
        bool[] buttonData;
        int[] POV;
        public bool Reset;

        internal bool StartCS2()
        {
            SD.DirectInput directInput = new SD.DirectInput();
            var devices = directInput.GetDevices(SD.DeviceClass.GameController, SD.DeviceEnumerationFlags.AttachedOnly);
            foreach (SD.DeviceInstance di in devices)
            {
                if (di.InstanceName != "SpaceNavigator")
                {
                    joystick = new SD.Joystick(directInput, di.InstanceGuid);

                    break;
                }
            }

            if (joystick == null)    //czy udalo sie połaczyc z urzadzeniem
                return false;

            joystick.Acquire();

//TODO: wypełnić tablice początkową.

            return true;
        }

        internal void Update()
        {
            state = joystick.GetCurrentState();
            buttonData = state.GetButtons();
            POV = state.GetPointOfViewControllers();
            Reset = buttonData[0];
        }

        internal Vector3 GetRotationOffset()
        {
            int x = (int)(state.X / 6553.60F);
            int y = (int)(state.Y / 6553.60F);

//TODO: mediana z 5 ostatnich wartości

            return (new Vector3(x / 10.0F, y / 10.0F, state.RotationZ / 65536.0F) - new Vector3(0.41F, 0.37F, 0.5F)) * 0.1F;
        }

        internal Vector3 GetPositionOffset()
        {
            float degree = POV[0];
            int x, y;
            if (degree == -1)
            {
                x = 0;
                y = 0;
            }
            else
            {
                degree /= 100;
                x = (int)Math.Round(Math.Sin(degree.ToRadian()), 0);
                y = (int)Math.Round(Math.Cos(degree.ToRadian()), 0);
            }

            int z = 0;
            if (buttonData[1])
                z = 1;
            else if (buttonData[2])
                z = -1;

            int szybkos_przesuwania = 5;
            return new Vector3(x, y, z) * szybkos_przesuwania;
        }
    }
}
