﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;

namespace Rotplucs
{
    static class Cut
    {
        static List<int> wierzcholkiDoUsuniecia;
        static Wielokat WielokatGlowny;
        static List<PunktNaKrawedzi> PodzieloneKrawedzie;
        static Dictionary<int, Wielokat> WielokatyBoczne;
        static public PolyShape pS;

        /// <summary>
        /// odcina fragment zly
        /// </summary>
        /// <param name="cross">vektor normalny płaszczyzny</param>
        /// <param name="point">nalezacy do płaszczyzny</param>
        ///  internal static void RemoveWrongVertax(Vector3 firstClick, Vector3 secondClick, Vector3 Camera)
        public static void MakeACut(PolyShape polyShape, Vector3 firstClick, Vector3 secondClick, Vector3 point)
        {
            pS = polyShape;

            Plaszczyzna plaszczyzna = new Plaszczyzna(point, firstClick, secondClick, Vector3.Zero);
             
            PodzieloneKrawedzie = new List<PunktNaKrawedzi>();
            List<int> trojkatyDoPodzielenia = new List<int>();
            wierzcholkiDoUsuniecia = new List<int>();

            //TODO: jak omijac nieuzywane wierzcholki? czyli usuniete z figury, ale nei usuniete z listy, zeby nie psuly trójkątów
            for (int vertex = 0; vertex < pS.verticesCount(); vertex++)
            {
                //sprawdz po ktorej stronie plaszczyzny jest wierzcholek
                float odleglosc = Geometry.OdlegloscPktDoPla(pS.VerticesPos(vertex), plaszczyzna);
                if (odleglosc < 0)
                {
                    wierzcholkiDoUsuniecia.Add(vertex);

                    for (int j = 0; j < pS.indicesCount(); j += 3)
                    {
                        for (int k = 0; k < 3; k++)
                        {
                            if (pS.Triangles(j + k) == vertex)   //sprawdz czy wierzcholek trojkatu jest wierzchołkiem poza
                                if (!trojkatyDoPodzielenia.Exists(x => x == j))
                                    trojkatyDoPodzielenia.Add(j);
                        }
                    }
                }
            }

            WielokatyBoczne = new Dictionary<int, Wielokat>();
            WielokatGlowny = new Wielokat(plaszczyzna);

            foreach (var t in trojkatyDoPodzielenia)
            {
                podzielTrojkat(t, plaszczyzna);
            }

            //usuwa wszystkie, a nie tylko te trójkąty które w całośbi były poza płaszczyzną tnącą 
            foreach (var v in wierzcholkiDoUsuniecia)
            {
                Geometry.RemoveVertax(v);
            }

            Polygons.CreateAll(WielokatGlowny, WielokatyBoczne, pS);
        }




        /// <summary>
        /// dla podanego indexu początku trojkąta, dzieli go na 3 trójkąty według płaszczyzny cięcia
        /// </summary>
        /// <param name="trojkat"></param>
        private static void podzielTrojkat(int trojkat, Plaszczyzna pla)
        {
            //znajdz wierzchołek pojedynczy, niezależnei po której stronie,
            //ale tak, że jeden po jednej a 2 po drugiej, 
            //jak inna sytuacja to nie ma takiego wierzchołka i koniec
            int pojedynczy = Geometry.ZnajdzWierzcholekPojedynczy(trojkat, pla);

            if (pojedynczy >= 0)
            {
                int podwojny1 = trojkat + (pojedynczy + 1) % 3;
                int podwojny2 = trojkat + (pojedynczy + 2) % 3;
                pojedynczy += trojkat;

                int p0 = pS.Triangles(pojedynczy);
                int p1 = pS.Triangles(podwojny1);
                int p2 = pS.Triangles(podwojny2);

                bool visible1 = pS.IsVisibleEdge(p0, p1);
                bool visible2 = pS.IsVisibleEdge(p0, p2);
                int poly = pS.getPolyNumberFromTriangle(trojkat);


                

                int nowy1 = ZnajdzPunktNaKrawedzi(p0, p1, visible1, pla);
                int nowy2 = ZnajdzPunktNaKrawedzi(p0, p2, visible2, pla);

                WielokatGlowny.Krawedzie.Add(new Krawedz(nowy1,nowy2));

                

                if (!WielokatyBoczne.ContainsKey(poly))
                    WielokatyBoczne[poly] = new Wielokat(new Plaszczyzna(Geometry.Normalna(p0, p1, p2), pS.VerticesPos(p0)));
                WielokatyBoczne[poly].Krawedzie.Add(new Krawedz(nowy1, nowy2));


                bool czyPojedynczyDoUsunieia = IsWierzcholekDoUsuniecia(p0);


                if(czyPojedynczyDoUsunieia)
                {
                    //Geometry.AddTriangle(pS.Triangles(podwojny1), nowy2, nowy1);
                    //Geometry.AddTriangle(pS.Triangles(podwojny1), pS.Triangles(podwojny2), nowy2);

                    if (visible1)
                        WielokatyBoczne[poly].Krawedzie.Add(new Krawedz(p1, nowy1));
                    else
                        pS.AddInvisible(p1, nowy1);

                    if (visible2)
                        WielokatyBoczne[poly].Krawedzie.Add(new Krawedz(p2, nowy2));
                    else
                        pS.AddInvisible(p2, nowy2);

                    WielokatyBoczne[poly].Krawedzie.Add(new Krawedz(p1, p2));
                }
                else
                {
                    if (visible1)
                        WielokatyBoczne[poly].Krawedzie.Add(new Krawedz(p0, nowy1));
                    if (visible2)
                        WielokatyBoczne[poly].Krawedzie.Add(new Krawedz(p0, nowy2));

                    //pS.indices[podwojny1] = (ushort)nowy1;
                    //pS.indices[podwojny2] = (ushort)nowy2;
                }
            }
        }

        private static bool IsWierzcholekDoUsuniecia(int p0)
        {
            foreach (var v in wierzcholkiDoUsuniecia)
            {
                if (v == p0)
                    return true;
            }
            return false;
        }
        

        private static int ZnajdzPunktNaKrawedzi(int pojedynczy, int podwojny, bool visibility, Plaszczyzna p)
        {
            int nowy;
            PunktNaKrawedzi pnk1 = PodzieloneKrawedzie.Find(x => (x.V1 == pojedynczy && x.V2 == podwojny) || (x.V1 == podwojny && x.V2 == pojedynczy));
            if (pnk1 == null)
            {
                if (visibility)
                {
                    Vector3 tmp1 = ZnajdzPunktNaProstej(pojedynczy, podwojny, p);
                    nowy = Geometry.AddVertax(tmp1);
                }
                else
                    nowy = pS.GetNewVirtualVeraxNumber();


                PodzieloneKrawedzie.Add(new PunktNaKrawedzi(pojedynczy, podwojny, nowy));
            }
            else
                nowy = pnk1.Point;

            return nowy;
        }

        private static Vector3 ZnajdzPunktNaProstej(int p1, int p2, Plaszczyzna pla)
        {
            Vector3 wierzcholek1 = pS.VerticesPos(p1);
            Vector3 wierzcholek2 = pS.VerticesPos(p2);
            return Geometry.WhereLineIntersectsSurface(wierzcholek1, wierzcholek2, pla);
        }
    }
}
