﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Rotplucs
{
    static class EdycjaZmian
    {
        static int NumerEdycji;
        static int OstatniaEdycja;

        static List<Stack<Trojkat>> dodaneTrojkaty;
        static List<Stack<Trojkat>> usunieteTrojkaty;

        /// <summary>
        /// ustawia zmienne początkowe
        /// </summary>
        public static void EdycjaStart()
        {
            dodaneTrojkaty = new List<Stack<Trojkat>>();
            usunieteTrojkaty = new List<Stack<Trojkat>>();
            NumerEdycji = -1;
            OstatniaEdycja = NumerEdycji;
        }

        /// <summary>
        /// rozpoczyna kolejną edycję
        /// </summary>
        public static void NowaEdycja()
        {
            if (OstatniaEdycja > NumerEdycji)
            {
                dodaneTrojkaty.RemoveRange(NumerEdycji + 1, OstatniaEdycja - NumerEdycji);
                usunieteTrojkaty.RemoveRange(NumerEdycji + 1, OstatniaEdycja - NumerEdycji);
            }
            NumerEdycji++;
            OstatniaEdycja = NumerEdycji;

            dodaneTrojkaty.Add(new Stack<Trojkat>());
            usunieteTrojkaty.Add(new Stack<Trojkat>());
        }

        public static void CofnijEdycje()
        {
            if (NumerEdycji < 0)
                return;

            foreach (Trojkat t in dodaneTrojkaty[NumerEdycji])
            {
                Geometry.RemoveTriagle(t.Pozycja, false);
            }

            foreach (Trojkat t in usunieteTrojkaty[NumerEdycji])
            {
                Geometry.AddTriangleAt(t.NumerWielokata, t.P1, t.P2, t.P3, t.Pozycja);
            }

            NumerEdycji--;
        }

        public static void PowtorzEdycje()
        {
            if (NumerEdycji >= OstatniaEdycja)
                return;
            NumerEdycji++;

            foreach (Trojkat t in usunieteTrojkaty[NumerEdycji].Reverse())
            {
                Geometry.RemoveTriagle(t.Pozycja, false);
            }

            foreach (Trojkat t in dodaneTrojkaty[NumerEdycji].Reverse())
            {
                Geometry.AddTriangle(t.NumerWielokata, t.P1, t.P2, t.P3,  false);//
            }
        }


        public static void ZapiszDodanie(Trojkat p)
        {
            dodaneTrojkaty[NumerEdycji].Push(p);
        }

        public static void ZapiszUsuniecie(Trojkat trojkat)
        {
            usunieteTrojkaty[NumerEdycji].Push(trojkat);
        }
    }
}
