﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using FBX;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework;

namespace Rotplucs
{
    static class FileIO
    {
        
        public static string templatePath = "Content\\box.fbx";
        public static string savePath = "sculpture.fbx";
        public static string openPath = "Content\\sphere.fbx";


        public static void Save(PolyShape ps)
        {
            Reader _plik = new Reader(templatePath);
            _plik.Open();


            //usuwanie nieuzywanych wierzcholkow
            var vertexyZps = ps.GetAllVertices();
            var indexyZps = ps.GetAllIndices();

            var vertexy = new List<StringNode>();
            var indexy = new List<StringNode>();

            int[] mapowanie = new int[vertexyZps.Count];
            //tablica mapujaca
            int nowyNumer = 1;

            for (int i = 0; i < indexyZps.Count; i++)
            {
                int numerWierzcholka = indexyZps[i];
                if(mapowanie[numerWierzcholka] == 0)
                {
                    mapowanie[numerWierzcholka] = nowyNumer;
                    nowyNumer++;

                    var wierzcholek = vertexyZps[numerWierzcholka];

                    vertexy.Add(new StringNode(wierzcholek.Position.X));
                    vertexy.Add(new StringNode(wierzcholek.Position.Y));
                    vertexy.Add(new StringNode(wierzcholek.Position.Z));
                }

            }

            //trzeba zamienic CW z CCW
            
            for (int i = 0; i < indexyZps.Count; i += 3)
            {
                /*
                //CW 
                indexy.Add(new StringNode(mapowanie[indexyZps[i]] - 1));
                indexy.Add(new StringNode(mapowanie[indexyZps[i+1]] - 1));
                indexy.Add(new StringNode(-(mapowanie[indexyZps[i + 2]])));  //(x*(-1) - 1) - jako koniec wielokąta
                 */

                indexy.Add(new StringNode(mapowanie[indexyZps[i+2]] - 1));
                indexy.Add(new StringNode(mapowanie[indexyZps[i + 1]] - 1));
                indexy.Add(new StringNode(-(mapowanie[indexyZps[i]])));  //(x*(-1) - 1) - jako koniec wielokąta
            }


            _plik.Objects.Geometry.Vertices.Ilosc = vertexy.Count;
            _plik.Objects.Geometry.Vertices.Lista = vertexy;

            _plik.Objects.Geometry.Indices.Ilosc = indexy.Count;
            _plik.Objects.Geometry.Indices.Lista = indexy;


            Writer w = new Writer(_plik.Nodes);
            w.Save(savePath);
        }

        public static void Open(PolyShape ps)
        {
            Reader _plik = new Reader(openPath);

            _plik.Open();

            var vertexy = new List<StringNode>();
            var indexy = new List<StringNode>();

            vertexy = _plik.Objects.Geometry.Vertices.Lista;
            indexy = _plik.Objects.Geometry.Indices.Lista;

            ps.Clear();

            for(int v=0 ; v < vertexy.Count ; v+=3)
            {
                ps.AddVertex(new Vector3(vertexy[v].ToFloat(), vertexy[v+1].ToFloat(), vertexy[v+2].ToFloat()));
            }



            for(int i=0 ; i < indexy.Count ; i+=3)
            {
                /*
                //CW 
                ps.AddIndices(indexy[i].ToInt());
                ps.AddIndices(indexy[i+1].ToInt());
                ps.AddIndices(-indexy[i+2].ToInt() - 1);
                */

                ps.AddIndices(-indexy[i + 2].ToInt() - 1);
                ps.AddIndices(indexy[i + 1].ToInt());
                ps.AddIndices(indexy[i].ToInt());


                ps.AddPolygons(i);
            }

            //ps.SetVertices();
            //_plik.Takes.Take;
        }
    }
}
