﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Input;

namespace Rotplucs.Input
{
    public static class CameraInput
    {
        static public Vector3 cameraPos;  //powinno byc private
        static public Vector3 cameraRot;  //Yaw,Pitch,Roll
        static public Matrix worldDifineByCamera;


        public static void Reset()
        {
            cameraPos = Constants.StartingCameraPos;
            worldDifineByCamera = Matrix.Identity;
        }

        public static void Update()
        {
            if (MyInput.IsResetWidoku())
                Reset();

            if (MyInput._CS2 != null)
                UpdateCameraUsingJoystick();
            if (MyInput._3Dx != null)
                UpdateCameraUsing3DMouse();
            UpdateCameraUsingKeys();

            UpdateWorld();
        }

        public static Vector3 Poprawka(Vector3 mousePosition)
        {
            //mousePosition *= 85;   // bo kąt widzenia jest MathHelper.PiOver4

            //Vector3 Position = Vector3.Forward;
            // Position = Vector3.Transform(Position, Matrix.Invert(worldDifineByCamera));
            //Position = Vector3.Transform(Position, (Matrix.CreateTranslation(cameraPos.X, cameraPos.Y, cameraPos.Z)));

            Vector3 Position = new Vector3(cameraPos.X, cameraPos.Y, cameraPos.Z) + mousePosition;
            Position = Vector3.Transform(Position, Matrix.Invert(worldDifineByCamera));
            
            //Position = Vector3.Transform(Position, Matrix.CreateTranslation(mousePosition));

            //mousePosition.Z *= -1;
            return Position;
        }

        public static Vector3 rotationVector()
        {
            return Vector3.Transform(Vector3.Forward, Matrix.Invert(worldDifineByCamera));
        }

#region Prywatne
        private static void UpdateCameraUsingKeys()
        {
            //obrót
            if (MyInput._Keyboard.IsKeyDown(Keys.Up))
                cameraRot.Y -= 0.05f;
            if (MyInput._Keyboard.IsKeyDown(Keys.Down))
                cameraRot.Y += 0.05f;
            if (MyInput._Keyboard.IsKeyDown(Keys.Left))
                cameraRot.X -= 0.05f;
            if (MyInput._Keyboard.IsKeyDown(Keys.Right))
                cameraRot.X += 0.05f;
            if (MyInput._Keyboard.IsKeyDown(Keys.Home))
                cameraRot.Z -= 0.05f;
            if (MyInput._Keyboard.IsKeyDown(Keys.End))
                cameraRot.Z += 0.05f;
            
            //przesuwanie
            if (MyInput._Keyboard.IsKeyDown(Keys.Q))
                cameraPos.Z -= 5;
            if (MyInput._Keyboard.IsKeyDown(Keys.E))
                cameraPos.Z += 5;
            if (MyInput._Keyboard.IsKeyDown(Keys.W))
                cameraPos.Y += 5;
            if (MyInput._Keyboard.IsKeyDown(Keys.S))
                cameraPos.Y -= 5;
            if (MyInput._Keyboard.IsKeyDown(Keys.A))
                cameraPos.X -= 5;
            if (MyInput._Keyboard.IsKeyDown(Keys.D))
                cameraPos.X += 5;
        }

        private static void UpdateCameraUsing3DMouse()
        {
            cameraRot = MyInput._3Dx.GetRotationOffset();
            cameraPos -= MyInput._3Dx.GetPositionOffset();
        }

        private static void UpdateCameraUsingJoystick()
        {
            cameraRot = MyInput._CS2.GetRotationOffset();
            cameraPos -= MyInput._CS2.GetPositionOffset();
        }

        private static void UpdateWorld()
        {
            worldDifineByCamera *= Helper.CreateFromYawPitchRoll(cameraRot);
        }
#endregion
    }
}
