﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Rotplucs.Input;

namespace Rotplucs
{
    public partial class RotplucsForm : Form
    {
        public RotplucsForm()
        {
            InitializeComponent();

            Error.Init(this);

            //this.WindowState = FormWindowState.Normal;
            //this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.None;
            //this.Bounds = Screen.PrimaryScreen.Bounds;
        }


        public IntPtr getDrawSurface()
        {
            return pctSurface.Handle;
        }

        private void cofnijToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MyInput.isCofnij = true;
        }

        private void powtórzToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MyInput.isPowtorz = true;
        }

        private void otwórzToolStripMenuItem_Click(object sender, EventArgs e)
        {
            DialogResult result = openFileDialog1.ShowDialog(); // Show the dialog.
            if (result == DialogResult.OK) // Test result.
            {
                FileIO.openPath = openFileDialog1.FileName;
                MyInput.isOdczyt = true;
            }
        }

        private void zapiszToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MyInput.isZapis = true;
        }

        private void zamknijToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void RotplucsForm_FormClosed(object sender, FormClosedEventArgs e)
        {
            Application.Exit();
        }

        private void resetToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MyInput.isReset = true;
        }

        private void nowyToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MyInput.isNew = true;
        }



        private void RotplucsForm_Load(object sender, EventArgs e)
        {
            UpdateResolution();
            MyInput.ConeAngle = coneAngleBar.Value;
        }

        private void RotplucsForm_Resize(object sender, EventArgs e)
        {
            UpdateResolution();
        }

        private void UpdateResolution()
        {
            Constants.WindowSize = new Microsoft.Xna.Framework.Point(pctSurface.Size.Width, pctSurface.Size.Height);
        }





        private void pctSurface_MouseMove(object sender, MouseEventArgs e)
        {
            ZrobCosZTaMysza(e);
        }

        private void pctSurface_MouseDown(object sender, MouseEventArgs e)
        {
            ZrobCosZTaMysza(e);
        }

        private void pctSurface_MouseUp(object sender, MouseEventArgs e)
        {
            ZrobCosZTaMysza(e);
        }
        
        private void ZrobCosZTaMysza(MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
                MyInput.SetState(e.X, e.Y, Microsoft.Xna.Framework.Input.ButtonState.Pressed, Microsoft.Xna.Framework.Input.ButtonState.Released);
            else if (e.Button == MouseButtons.Right)
                MyInput.SetState(e.X, e.Y, Microsoft.Xna.Framework.Input.ButtonState.Released, Microsoft.Xna.Framework.Input.ButtonState.Pressed);
            else
                MyInput.SetState(e.X, e.Y, Microsoft.Xna.Framework.Input.ButtonState.Released, Microsoft.Xna.Framework.Input.ButtonState.Released);
        }

        private void sterowanieToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Sterowanie widokiem kamery:" + Environment.NewLine
                + "  W - kamera w górę" + Environment.NewLine
                + "  S   - kamera w dół" + Environment.NewLine
                + "  A  - kamera w lewo" + Environment.NewLine
                + "  D  - kamera w prawo" + Environment.NewLine
                + "  Q  - kamera do przodu (zoom)" + Environment.NewLine
                + "  E   - kamera do tyłu (zoom)" + Environment.NewLine
                + "  Home/End - obrót w osi kamery" + Environment.NewLine
                + "  Strzałki - obrót w pozostałych osiach" + Environment.NewLine);
        }

        private void informacjeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Projekt realizowany w ramach przedmiotu Rzeczywistość Wirtualna" + Environment.NewLine
                + "Autorzy:" + Environment.NewLine
                + "  - Andrzej Fałkowski" + Environment.NewLine
                + "  - Dawid Kwiatkowski" + Environment.NewLine
                + "  - Paweł Pieniążek" + Environment.NewLine);
        }

        private void coneAngleBar_Scroll(object sender, EventArgs e)
        {
            MyInput.ConeAngle = coneAngleBar.Value;
        }
    }
}
