﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework;

namespace Rotplucs
{
    /*static class GUI
    {
        static private SpriteBatch _spriteBatch;
        static private MouseState mouse;
        static private int hotItem = -1;
        static private int activeItem = -1;


        static private Texture2D backgroundTexture;
        static private Texture2D gripTexture;
        static private float scrollvalue = 0;
        static private Texture2D buttonTexture;
        static GraphicsDevice _gd;


        public static void Load(Texture2D buttonName, Texture2D railTexture, Texture2D thumbTexture, GraphicsDevice graphicsDevice)
        {
            buttonTexture = buttonName;
            backgroundTexture = railTexture;
            gripTexture = thumbTexture;
            _gd = graphicsDevice;
            _spriteBatch = new SpriteBatch(graphicsDevice);
        }





        static public void Update(GameTime gameTime)
        {
            mouse = Mouse.GetState();
        }

        static public void Begin()
        {
            //Clear hot items before we begin.
            hotItem = -1;
            _spriteBatch.Begin(SpriteSortMode.Immediate, BlendState.AlphaBlend);
        }

        static public void End()
        {
            _spriteBatch.End();
            //If the user isn't clicking anything anymore, unset the active item.
            if (mouse.LeftButton == ButtonState.Released)
            {
                activeItem = -1;
            }
        }

        /// <summary>
        /// Draws a standard button with specified texture at the location of the rectangle
        /// and returns if the button was clicked.
        /// </summary>
        /// <param name="id">Unique ID</param>
        /// <param name="rectangle">Rectangle specifying the position of the button</param>
        /// <param name="texture">Texture for the button</param>
        /// <returns>True if button was clicked, otherwise False</returns>
        static public bool DoButton(int id, Rectangle rectangle, Texture2D texture)
        {
              //Determine if we're hot, and maybe even active
              if (MouseHit(rectangle))
              {
                    hotItem = id;
                    if (activeItem == -1 && mouse.LeftButton == ButtonState.Pressed)
                            activeItem = id;
              }
 
              //Draw the button  
              Color drawColor;
              if (hotItem == id)
              {
                if (activeItem == id)
                    {
                        drawColor = Color.White;
                    }
                    else
                    {
                         drawColor = Color.LightGray;
                    }
              }
              else
              {
                    drawColor = Color.Gray;
              }
              _spriteBatch.Draw(texture, rectangle, drawColor);
 
              //If we are hot and active but the mouse is no longer down, we where clicked
              //Line updated after comment by anonymous user, I feel so silly now!
                    return mouse.LeftButton == ButtonState.Released && hotItem == id && activeItem == id;
        }

        //Small helper function that checks if the mouse is contained in the rectangle
        //Might even be unneeded but I like not having to manually write ‘new Point…’ every time.
        static private bool MouseHit(Rectangle rectangle)
        {
            return rectangle.Contains(new Point(mouse.X, mouse.Y));
        }



        


         
         static public void DrawImGui(GameTime gameTime)
         {
             Update(gameTime); //normally you would do this in the Update method of your screen
             //but for code-compactness reasons in tutorials, I'll just add it here
             Begin();

             if (DoButton(1, new Rectangle(_gd.Viewport.Width - 64, 0, 64, 64), buttonTexture))
             {
                 Console.Out.WriteLine("The button with id: 1 was pressed");
             }

             //More GUI items
             scrollvalue = DoScrollbar(2, new Rectangle(10, 100, 50, 500), backgroundTexture, gripTexture, 90, scrollvalue, false);

             End();
         }


         static Color ActiveColor = Color.Red;
         static Color InActiveColor = Color.Blue;

         /// <summary>
         /// Draws a vertical or horizontal scrollbar at the specified position. If the grip was moved, returns the new value, else returns the inserted value
         /// </summary>        
         static public float DoScrollbar(int id, Rectangle rectangle, Texture2D scrollbarTexture, Texture2D gripTexture, float max, float value, bool horizontal)
         {
             //No matter the input, value should be at least 0 and at most max
             value = Math.Min(Math.Max(value, 0), max);

             //Determine if we're hot, and maybe even active
             if (MouseHit(rectangle)) //See previous part's code for this method
             {
                 hotItem = id;
                 if (activeItem == -1 && mouse.LeftButton == ButtonState.Pressed)
                     activeItem = id;
             }

             //Draw the scrollbar
             _spriteBatch.Draw(scrollbarTexture, rectangle, Color.White);

             //Position the grip relative on the scrollbar and make sure the grip stays inside the scrollbar
             //Note that the grip's width if vertical/height if horizontal is the scrollbar's smallest dimension.
             int gripPosition; Rectangle grip;
             if (horizontal)
             {
                 gripPosition = rectangle.Left + (int)((rectangle.Width - rectangle.Height) * (value / max));
                 grip = new Rectangle(gripPosition, rectangle.Top, rectangle.Height, rectangle.Height);
             }
             else
             {
                 gripPosition = rectangle.Bottom - rectangle.Width - (int)((rectangle.Height - rectangle.Width) * (value / max));
                 //PP
                    grip = new Rectangle(rectangle.Left - 20, gripPosition, 100, 20);
             }

             //Draw the grip in the correct color
             if (activeItem == id || hotItem == id)
             {
                 _spriteBatch.Draw(gripTexture, grip, ActiveColor);
             }
             else
             {
                 _spriteBatch.Draw(gripTexture, grip, InActiveColor);
             }

             //If we're active, calculate the new value and do some bookkeeping to make sure the mouse and grip are in sync            
             if (activeItem == id)
             {
                 if (horizontal)
                 {
                     //Because the grip's position is defined in the top left corner
                     //we need to shrink the movable domain slightly so our grip doesnt
                     //draw outside the scrollbar, while still getting a full range.                    
                     float mouseRelative = mouse.X - (rectangle.X + grip.Width / 2);
                     mouseRelative = Math.Min(mouseRelative, rectangle.Width - grip.Width);
                     mouseRelative = Math.Max(0, mouseRelative);
                     //We then calculate the relative mouse offset 0 if the mouse is at
                     //the left end or more to the left. 1 if the mouse is at the right end
                     //or more to the right. We then multiply this by max to get our new value.
                     value = (mouseRelative / (rectangle.Width - grip.Width)) * max;
                 }
                 else
                 {
                     //same as horizontal bit in the end we inverse value,
                     //because we want the bottom to be 0 instead of the top
                     //while in y coordinates the top is 0.
                     float mouseRelative = mouse.Y - (rectangle.Y + grip.Height / 2);
                     mouseRelative = Math.Min(mouseRelative, rectangle.Height - grip.Height);
                     mouseRelative = Math.Max(0, mouseRelative);
                     value = max - (mouseRelative / (rectangle.Height - grip.Height)) * max;
                 }
             }
             return value;
         }

        static public float getScrollValue()
        {
            return (scrollvalue + 10) * 10;
        }
    }*/
}
