using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using System.Collections.Generic;
using Rotplucs.Input;

namespace Rotplucs
{
    public static class LineCone
    {
        static VertexPositionNormalTexture[] output;
        static short[] indexy;

        private static GraphicsDevice _gd;

        public static void Load(GraphicsDevice gd)
        {
            _gd = gd;
            indexy = new short[] { 0, 2, 2, 1, 1, 3, 3, 0, 0, 4, 1, 4, 2, 4, 3, 4 };
            output = new VertexPositionNormalTexture[5];
        }


        public static void Update(Vector3 MSpos, Vector3 MSrot)
        {
            int kat = MyInput.ConeAngle;
            int przesuniecie = 300; //tak, zeby stoek by widoczny lepiej

            Vector3 p = MSpos + MSrot * przesuniecie;
            Vector3[] piramidka = Geometry.CreateCone(p, MSrot, kat, Constants.ConeHeight - przesuniecie);


            for (int i = 0; i < piramidka.Length; i++)
                output[i] = new VertexPositionNormalTexture(piramidka[i], Vector3.Zero, Vector2.Zero);
        }


        public static void Draw(Matrix world, Matrix view, Matrix projection)
        {
            //var basicEffect = new BasicEffect(_gd) { View = view, Projection = projection, World = world };

            if (output != null)
            {
                //basicEffect.CurrentTechnique.Passes[0].Apply();

                _gd.DrawUserIndexedPrimitives(
                    PrimitiveType.LineList,
                    output, 0, 5,
                    indexy, 0, 8
                    );
            }
        }
    }
}