using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using System.Collections.Generic;

namespace Rotplucs
{
    public static class LineMove
    {
        static List<VertexPositionNormalTexture> punkty;
        static List<short> indexy;

        private static GraphicsDevice _gd;

        public static void Load(GraphicsDevice gd)
        {
            _gd = gd;
        }

        public static void NewLine()
        {
            punkty = new List<VertexPositionNormalTexture>();
            indexy = new List<short>();
        }

        public static void AddPoint(Vector3 pos)
        {
            indexy.Add((short)(punkty.Count));
            punkty.Add(new VertexPositionNormalTexture(pos, Vector3.Zero, Vector2.Zero));
        }

        public static int Count
        {
            get
            {
                return punkty.Count;
            }
        }

        public static void Draw(Matrix world, Matrix view, Matrix projection)
        {
            //var basicEffect = new BasicEffect(_gd) { View = view, Projection = projection, World = world };

            if (punkty != null && punkty.Count > 1)
            {
                //basicEffect.CurrentTechnique.Passes[0].Apply();

                _gd.DrawUserIndexedPrimitives(
                    PrimitiveType.LineStrip,
                    punkty.ToArray(), 0, punkty.Count,
                    indexy.ToArray(), 0, indexy.Count -1
                    );
            }
        }
    }
}