﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework;

namespace Rotplucs
{
    public static class StartingCube
    {
        private static Vector3 _pos;
        private static Vector3 _size;
        private static int polygonCount = 6;

        internal static void SetPosAndSize(Vector3 pos, Vector3 size)
        {
            _pos = pos;
            _size = size;
        }

        /// <summary>
        /// bufor wierzchołków
        /// </summary>
        public static VertexPositionNormalTexture[] CreateVertexBuffer()
        {
            VertexPositionNormalTexture[] cubeVertices = new VertexPositionNormalTexture[8];

            //botom face
            cubeVertices[0].Position = _pos + new Vector3(-_size.Z, -_size.X, -_size.Y);
            cubeVertices[1].Position = _pos + new Vector3(-_size.Z, -_size.X, _size.Y);
            cubeVertices[2].Position = _pos + new Vector3(_size.Z, -_size.X, _size.Y);
            cubeVertices[3].Position = _pos + new Vector3(_size.Z, -_size.X, -_size.Y);

            //top face
            cubeVertices[4].Position = _pos + new Vector3(-_size.Z, _size.X, -_size.Y);
            cubeVertices[5].Position = _pos + new Vector3(-_size.Z, _size.X, _size.Y);
            cubeVertices[6].Position = _pos + new Vector3(_size.Z, _size.X, _size.Y);
            cubeVertices[7].Position = _pos + new Vector3(_size.Z, _size.X, -_size.Y);

            return cubeVertices;
        }



        /// <summary>
        /// bufor dla trójkątów
        /// </summary>
        public static UInt16[] CreateIndexBuffer()
        {
            UInt16[] cubeIndices = new UInt16[]{0,2,3, 2,0,1,
            7,5,4, 5,7,6, 
            4,1,0, 1,4,5,
            6,3,2, 3,6,7,
            6,2,1, 1,5,6,
            3,4,0, 3,7,4
            };

            return cubeIndices;
        }

        public static int[] CreateCubePolygonList()
        {
            int[] polies = new int[]{1, 1,
            2, 2, 
            3, 3,
            4, 4,
            5, 5,
            6, 6
            };

            return polies;
        }

        public static List<Krawedz> DodajInvisible()
        {
            var krawedzie = new List<Krawedz>();
            krawedzie.Add(new Krawedz(0, 2));
            krawedzie.Add(new Krawedz(5, 7));
            krawedzie.Add(new Krawedz(1, 4));
            krawedzie.Add(new Krawedz(3, 6));
            krawedzie.Add(new Krawedz(1, 6));
            krawedzie.Add(new Krawedz(3, 4));

            return krawedzie;
        }

        internal static int GetPolygonCount()
        {
            return polygonCount;
        }
    }
}
