﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;

namespace Rotplucs
{
    //klasa wykorzystywana do tworzenia wielkątów z dziurą
    //wykorzystujac obrys krawędziwowy obu

    public class PolygonOfTriangles
    {
        List<Trojkat> trojkaty;
        List<Krawedz> krawedzieNiewidoczne;
        private List<int> obrys;
        private bool isExists;
        public Krawedz lacznikWewZew;

        public PolygonOfTriangles()
        {
            isExists = true;
            trojkaty = new List<Trojkat>();
            krawedzieNiewidoczne = new List<Krawedz>();
        }

        public PolygonOfTriangles(List<int> krawedziowaPostac) : this()
        {
            //shallow copy, ale chyba wystarczy
            obrys = krawedziowaPostac.GetRange(0, krawedziowaPostac.Count);
        }

        public List<int> getObrys()
        {
            return obrys;
        }

        internal void AddTrojkat(Trojkat t)
        {
            trojkaty.Add(t);
        }

        internal void AddKrawedz(Krawedz krawedz)
        {
            krawedzieNiewidoczne.Add(krawedz);
        }

        public void Delete()
        {
            isExists = false;
        }

        internal void AddToPolyShape(int numerWielokata, PolyShape pS)
        {
            if (isExists)
            {
                foreach (var t in trojkaty)
                    Geometry.AddTriangle(numerWielokata, t);

                foreach (var k in krawedzieNiewidoczne)
                    pS.AddInvisible(k);
            }
        }

        //zwraca punkt należący do wielokąta
        internal int GetPunkt()
        {
            return trojkaty[0].P1;
        }

        internal bool IsWielokatZawieraPunkt(Vector3 punkt)
        {
            foreach(var t in trojkaty)
                if(Geometry.IsPointInTriangle(punkt, t))
                    return true;
            return false;
        }

        internal List<int> GetNowyObrysZwewnetrznym(PolygonOfTriangles pot)
        {
            List<int> obrysWewnetrzny = pot.getObrys();
            float min = 100000;
            int Z = 0, W = 0;

            //znalezc najbliżesz punkty
            //trzeba wszystkei sprawdzić, bo albo w środkowym, albo w zewnętrznym mogliśmy być w jakimś zawijasie
            for (int zew = 0; zew < this.obrys.Count; zew++)
            {
                for (int wew = 0; wew < obrysWewnetrzny.Count; wew++)
                {
                    float odl = Geometry.OdlegloscPomiedzy(this.obrys[zew], obrysWewnetrzny[wew]);
                    if(odl < min)
                    {
                        min = odl;
                        Z = zew;
                        W = wew;
                    }
                }
            }


        //polaczyc obrys wewnetzny z zewnetrznym w meijscu gdzie ejst najbliżej
            List<int> tmp = obrysWewnetrzny.GetRange(0,W+1);
            obrysWewnetrzny.RemoveRange(0,W+1);
            obrysWewnetrzny.AddRange(tmp);
            obrysWewnetrzny.Reverse();
            obrysWewnetrzny.Add(obrysWewnetrzny[0]);

            tmp = obrys;
            
            //HACK, musi być jako invisieble edges, ale łatwo tego nei przekażemy
            lacznikWewZew = new Krawedz(obrysWewnetrzny[0], tmp[Z]);

            tmp.Insert(Z, tmp[Z]);
            tmp.InsertRange(Z+1, obrysWewnetrzny);
            return tmp;
        }
    }
}
