﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;

namespace Rotplucs
{
    public static class Polygons
    {
        public static void CreateAll(Wielokat WielokatGlowny, Dictionary<int, Wielokat> WielokatyBoczne, PolyShape pS)
        {
            CreatePolygons(WielokatGlowny, pS.GetNewPolygon(), pS);
            CreateSidePolygons(WielokatyBoczne, pS);

        }

        public static void CreateAll(List<Wielokat> wielokatyPiramidy, Dictionary<int, Wielokat> WielokatyBoczne, PolyShape pS)
        {
            foreach (var w in wielokatyPiramidy)
            {
                CreatePolygons(w, pS.GetNewPolygon(), pS);
            }
            CreateSidePolygons(WielokatyBoczne, pS);
        }


        private static void CreateSidePolygons(Dictionary<int, Wielokat> WielokatyBoczne, PolyShape pS)
        {
            foreach (var w in WielokatyBoczne)
            {
                CreatePolygons(w.Value, w.Key, pS);
            }
        }

        /*
        //dodaje trojkaty tworząc wielokąt, nakładajace się krawędzie się niwielują i znikają z obrysu
        public static void CreatePolygonFromTriangles(List<Trojkat> trojkaty, Wielokat w)
        {
            foreach (var t in trojkaty)
            {
                AddToWielokat(t, w);
            }
        }

        private static void AddToWielokat(Trojkat trojkat, Wielokat w)
        {
            SprawdzKrawedz(trojkat.P1, trojkat.P2, w);
            SprawdzKrawedz(trojkat.P2, trojkat.P3, w);
            SprawdzKrawedz(trojkat.P1, trojkat.P3, w);
        }

        private static void SprawdzKrawedz(int P1, int P2, Wielokat w)
        {
            var krawedz = w.Krawedzie.Find(x => (x.P1 == P1 && x.P2 == P2));
            if (krawedz == null)
                w.Krawedzie.Add(new Krawedz(P1, P2));
            else
                w.Krawedzie.Remove(krawedz);
        }
        */

        /// <summary>
        /// tworzy wielokaty na podstawie krawedzi - nie trzeba sortować, powstają spójne wielokąty
        /// </summary>
        private static void CreatePolygons(Wielokat w, int poly, PolyShape pS)
        {
            List<PolygonOfTriangles> wszystkieWielokaciki =  PreparePolygones(w,poly,pS);

            if(wszystkieWielokaciki.Count != 1)
            {
                //albo wielokąty są 2 na jednej płaszczyźnie jako rozłączne,
                //albo jeden jest wewnątrz drugiego
                //rozłącznych może byc kilka

                for (int wew = 0; wew < wszystkieWielokaciki.Count; wew++)
                {
                    Vector3 punkt = pS.VerticesPos(wszystkieWielokaciki[wew].GetPunkt());
                    bool wielokatWewnetrzny = false;
                    int parent = 0;
                    for (int zew = 0; zew < wszystkieWielokaciki.Count; zew++)
                    {
                        if (wew != zew)
                        {
                            if (wszystkieWielokaciki[zew].IsWielokatZawieraPunkt(punkt))
                            {
                                wielokatWewnetrzny = true;
                                parent = zew;
                                break;
                            }
                        }
                    }
                    if (wielokatWewnetrzny)
                    {
                        //doczep do zew
                        List<int> obyrs = wszystkieWielokaciki[parent].GetNowyObrysZwewnetrznym(wszystkieWielokaciki[wew]);
                        Krawedz krawedzLaczaca = wszystkieWielokaciki[parent].lacznikWewZew;

                        wszystkieWielokaciki[parent] = CreatePolygon(w.Plaszcz, obyrs, poly, pS);

                        wszystkieWielokaciki[parent].AddKrawedz(krawedzLaczaca);


                        //oznacz jako pusty
                        wszystkieWielokaciki[wew].Delete();
                        
                    }
                }
            }

            for (int i = 0; i < wszystkieWielokaciki.Count; i++)
            {
                wszystkieWielokaciki[i].AddToPolyShape(poly, pS);
            }
        }

        private static List<PolygonOfTriangles> PreparePolygones(Wielokat w, int poly, PolyShape pS)
        {
            List<PolygonOfTriangles> wszystkieWielokaciki = new List<PolygonOfTriangles>();

            while (w.Krawedzie.Count >= 3)
            {
                List<int> wielokacik = new List<int>();

                int start = w.Krawedzie[0].P1;
                int end = w.Krawedzie[0].P2;

                if (end >= 0)
                    wielokacik.Add(end);
                w.Krawedzie.RemoveAt(0);

                bool zepsuty = false;

                while (start != end)
                {
                    var edge = w.Krawedzie.Find(x => x.P1 == end || x.P2 == end);
                    if (edge == null)
                    {
                        //CreatePolygon(w.Plaszcz, wielokacik, poly, pS);
                        zepsuty = true;
                        break;
 //JESLI TU WEJDZIE TO JEST NIEOOBRZE :P
                    }

                    if (edge.P1 == end)
                        end = edge.P2;
                    else
                        end = edge.P1;

                    if (end >= 0)
                        wielokacik.Add(end);
                    w.Krawedzie.Remove(edge);
                }
                if (zepsuty)
                    continue;

                PolygonOfTriangles pot = CreatePolygon(w.Plaszcz, wielokacik, poly, pS);
                if (pot != null)
                    wszystkieWielokaciki.Add(pot);
            }

            return wszystkieWielokaciki;
        }


        private static PolygonOfTriangles CreatePolygon(Plaszczyzna p, List<int> wielokat, int poly, PolyShape pS)
        {
            int numer0 = 0;
            int numer1 = 1;
            int numer2 = 2;
            int TESTER = wielokat.Count * 10;

            //obliczenia kierunku krawędzi wielokata, czy podany prawoskrętna krawedx czy lewoskrętna
            int wsp;
            float sumaKatow = 0;

            if (wielokat.Count <= 2)
                return null;

            while (numer0 < wielokat.Count)
            {
                Vector3 wektor1 = pS.VerticesPos(wielokat[numer1]) - pS.VerticesPos(wielokat[numer0]);
                Vector3 wektor2 = pS.VerticesPos(wielokat[numer2]) - pS.VerticesPos(wielokat[numer1]);

                sumaKatow += Geometry.SignedAngle(wektor1, wektor2,p);
                numer0++;

                numer1 = (numer0 + 1) % wielokat.Count;
                numer2 = (numer0 + 2) % wielokat.Count;
            }
            numer0 = 0;

//TODO: prawdopodobnie wsp można wywalić
            PolygonOfTriangles pot;
            if (sumaKatow > 0)
            {
                wsp = -1;
                wielokat.Reverse();
                wsp = 1;
            }
            else
            {
                wsp = 1;
            }
            
            pot = new PolygonOfTriangles(wielokat);

            while (wielokat.Count >= 3)
            {
                Vector3 wektor1 = pS.VerticesPos(wielokat[numer1]) - pS.VerticesPos(wielokat[numer0]);
                Vector3 wektor2 = pS.VerticesPos(wielokat[numer2]) - pS.VerticesPos(wielokat[numer1]);

                bool WierzcholekPojedynczyWTrojkacie = false;
                foreach (var punkt in wielokat)
                {
                    if (Geometry.IsPointInTriangle(pS.VerticesPos(punkt), pS.VerticesPos(wielokat[numer0]), pS.VerticesPos(wielokat[numer1]), pS.VerticesPos(wielokat[numer2])))
                    {
                        WierzcholekPojedynczyWTrojkacie = true;
                    }
                }

                //ten kat moze byc zły
                if (!WierzcholekPojedynczyWTrojkacie && Math.Atan2(Vector3.Dot(Vector3.Cross(wektor1, wektor2), p.Cross), Vector3.Dot(wektor1, wektor2)) * wsp < 0)
                {
                    Trojkat t = Geometry.GetTriangleUsingCross(wielokat[numer0], wielokat[numer1], wielokat[numer2], p.Cross);
                    pot.AddTrojkat(t); 

                    if (wielokat.Count > 3)   //ostatni jest widoczny
                        pot.AddKrawedz(new Krawedz(wielokat[numer0], wielokat[numer2]));

                    wielokat.RemoveAt(numer1);
                }
                else //następny?
                {
                    numer0++;
                    TESTER--;
                    if (TESTER <= 0)
                    {
                        break;
                    }
                }

                numer0 %= wielokat.Count;
                numer1 = (numer0 + 1) % wielokat.Count;
                numer2 = (numer0 + 2) % wielokat.Count;
            }

            return pot;
        }
    }
}
